using System;
using System.Data;

using SQLiteCSLib.Inner;

namespace SQLiteCSLib
{
	/// <summary>
	/// SQLitep[^
	/// </summary>
	public class SQLiteParameter : IDbDataParameter, IDataParameter, IComparable
	{
		/// <summary>
		/// RXgN^
		/// </summary>
		public SQLiteParameter()
		{
		}

		/// <summary>
		/// lp[^̗LvpeB
		/// </summary>
		public byte Precision
		{
			get
			{
				return 0;
			}
			set
			{
			}
		}

		/// <summary>
		/// lp[^̏vpeB
		/// </summary>
		public byte Scale
		{
			get
			{
				return 0;
			}
			set
			{
			}
		}

		/// <summary>
		/// p[^̃TCYvpeB
		/// </summary>
		public int Size
		{
			get
			{
				return 0;
			}
			set
			{
			}
		}

		/// <summary>
		/// o͕
		/// </summary>
		protected ParameterDirection m_dir = ParameterDirection.InputOutput;

		/// <summary>
		/// o͕vpeB
		/// </summary>
		public ParameterDirection Direction
		{
			get
			{
				return m_dir;
			}
			set
			{
				m_dir = value;
			}
		}

		/// <summary>
		/// ^
		/// </summary>
		protected DbType m_type = DbType.Object;

		/// <summary>
		/// ^vpeB
		/// </summary>
		public DbType DbType
		{
			get
			{
				return m_type;
			}
			set
			{
				m_type = value;
			}
		}

		/// <summary>
		/// l
		/// </summary>
		protected object m_value = null;

		/// <summary>
		/// lvpeB
		/// </summary>
		public object Value
		{
			get
			{
				return m_value;
			}
			set
			{
				m_value = value;

				//^ݒ
				if( m_value is string )
				{
					DbType = DbType.String;
				}
				else
					if( m_value is Int64 )
				{
					DbType = DbType.Int64;
				}
				else
					if( m_value is Int32 )
				{
					DbType = DbType.Int32;
				}
				else
					if( m_value is Int16 )
				{
					DbType = DbType.Int16;
				}
				else
					if( m_value is Boolean )
				{
					DbType = DbType.Boolean;
				}
				else
					if( m_value is double || m_value is float )
				{
					DbType = DbType.Double;
				}
				else
					if( m_value is decimal )
				{
					DbType = DbType.Decimal;
				}
				else
					if( m_value is Byte[] )
				{
					DbType = DbType.Binary;
				}
				else
					if( m_value == null )
				{
					DbType = DbType.Object;
				}
				else
					throw new DataException( string.Format("T|[ǧ^ł {0}",value.GetType().ToString()), null );
			}
		}

		/// <summary>
		/// NULL
		/// </summary>
		protected bool m_isnull = true;

		/// <summary>
		/// NULLvpeB
		/// T|[g
		/// </summary>
		public bool IsNullable
		{
			get
			{
				return m_isnull;
			}
		}

		/// <summary>
		/// f[^so[W
		/// </summary>
		protected DataRowVersion m_datarowver = DataRowVersion.Current;

		/// <summary>
		/// f[^so[WvpeB
		/// </summary>
		public DataRowVersion SourceVersion
		{
			get
			{
				return m_datarowver;
			}
			set
			{
				m_datarowver = value;
			}
		}

		/// <summary>
		/// p[^
		/// </summary>
		protected string m_paraname = "";

		/// <summary>
		/// p[^vpeB
		/// </summary>
		public string ParameterName
		{
			get
			{
				return m_paraname;
			}
			set
			{
				m_paraname = value;
			}
		}

		/// <summary>
		/// J
		/// </summary>
		protected string m_column = "";

		/// <summary>
		/// JvpeB
		/// </summary>
		public string SourceColumn
		{
			get
			{
				return m_column;
			}
			set
			{
				m_column = value;
			}
		}

		/// <summary>
		/// 
		/// </summary>
		protected int m_order = 0;

		/// <summary>
		/// vpeB
		/// </summary>
		public int Order
		{
			get
			{
				return m_order;
			}
			set
			{
				m_order = value;
			}
		}

		/// <summary>
		/// r
		/// </summary>
		/// <param name="obj"></param>
		/// <returns></returns>
		public int CompareTo(object obj)
		{
			SQLiteParameter target = obj as SQLiteParameter;

			if( m_order < target.m_order )
				return -1;

			if( m_order > target.m_order )
				return 1;

			return 0;
		}
	}
}
